#include "gps_foaf.h"
#include "entity.h"


#if INCLUDE_CLASS_POINT
sslog_class_t *CLASS_POINT;
#endif
#if INCLUDE_CLASS_PERSON
sslog_class_t *CLASS_PERSON;
#endif


#if INCLUDE_PROPERTY_LAT
sslog_property_t *PROPERTY_LAT;
#endif
#if INCLUDE_PROPERTY_LOCATION
sslog_property_t *PROPERTY_LOCATION;
#endif
#if INCLUDE_PROPERTY_SURNAME
sslog_property_t *PROPERTY_SURNAME;
#endif
#if INCLUDE_PROPERTY_LONG
sslog_property_t *PROPERTY_LONG;
#endif
#if INCLUDE_PROPERTY_ALT
sslog_property_t *PROPERTY_ALT;
#endif
#if INCLUDE_PROPERTY_FIRSTNAME
sslog_property_t *PROPERTY_FIRSTNAME;
#endif



/**
 * @brief Register ontology.
 *
 * It creates all structures, such as classes and properties. Use it firs in your propgramm.
 */
void register_ontology()
{    

#if INCLUDE_PROPERTY_LAT
PROPERTY_LAT = sslog_new_property("http://www.w3.org/2003/01/geo/wgs84_pos#lat", SSLOG_PROPERTY_TYPE_DATA);
#endif

#if INCLUDE_PROPERTY_LOCATION
PROPERTY_LOCATION = sslog_new_property("http://www.w3.org/2003/01/geo/wgs84_pos#location", SSLOG_PROPERTY_TYPE_OBJECT);
#endif

#if INCLUDE_PROPERTY_SURNAME
PROPERTY_SURNAME = sslog_new_property("http://xmlns.com/foaf/0.1/surname", SSLOG_PROPERTY_TYPE_DATA);
#endif

#if INCLUDE_PROPERTY_LONG
PROPERTY_LONG = sslog_new_property("http://www.w3.org/2003/01/geo/wgs84_pos#long", SSLOG_PROPERTY_TYPE_DATA);
#endif

#if INCLUDE_PROPERTY_ALT
PROPERTY_ALT = sslog_new_property("http://www.w3.org/2003/01/geo/wgs84_pos#alt", SSLOG_PROPERTY_TYPE_DATA);
#endif

#if INCLUDE_PROPERTY_FIRSTNAME
PROPERTY_FIRSTNAME = sslog_new_property("http://xmlns.com/foaf/0.1/firstName", SSLOG_PROPERTY_TYPE_DATA);
#endif


#if INCLUDE_CLASS_POINT
CLASS_POINT = sslog_new_class("http://www.w3.org/2003/01/geo/wgs84_pos#Point");
#endif

#if INCLUDE_CLASS_PERSON
CLASS_PERSON = sslog_new_class("http://xmlns.com/foaf/0.1/#Person");
#endif

}


