// File contains general information about SmartSlog. 
// It is used for doxygen only.

/**
 * @file    description.h
 * @author  Aleksandr A. Lomov <lomov@cs.karelia.ru>
 * @date    13 April, 2015
 * @brief   Contains information for doxygen mainpage and etc 
 
 * @mainpage SmartSlog version 0.6.6 with DAPI (Double API)
 *
 * @section DESCRIPTION
 *
 * SmartSlog is a library to implement Knowledge Processors for 
 * the Smart-M3 platform (http://sourceforge.net/projects/smart-m3/).
 * SmartSlog versions 0.6 higher supports double API:
 * <ul>
 * <li>high-level API is based on entities (classes, properties and individuals);</li>
 * <li>low-level API is based on triples and similar
 * with low-level KPIs (Knowledge Processors Interfaces).
 * KPIs examples: C_KPI (SmartSlog is based on it),
 * KPI_LOW (http://sourceforge.net/projects/kpilow),
 * JavaKPI (http://sourceforge.net/projects/smartm3-javakpi).</li>
 * </ul>
 *
 * Versions of SmartSlog under 0.6 support only high-level API and KPs implemented
 * with such versions are not fully compatable with 0.6 and higher versions.
 *
 * <b>Project page:</b> http://sourceforge.net/projects/smartslog/
 *
 * <br />
 *
 * The project is done by FRUCT Lab at the IT-park of
 * Petrozavodsk State University (PetrSU), Russia.
 * The development started in 2009, in 2015 started versions with Double API.
 *
 * <b>Project owner:</b> Sergey I. Balandin, PhD, Adjunct Professor,
 * General Chair Open Innovations Program FRUCT.<br />
 * <b>Head of PetrSU FRUCT Lab:</b> Iurii A. Bogoiavlenskii, PhD,
 * Head of Department of Computer Science, PetrSU.<br />
 * <b>Adviser and project leader:</b> Dmitry G. Korzun, PhD,
 * Adjunct Professor. <br>
 * <b>Developers:</b>  Aleksandr A. Lomov (2009-current time),
 * Pavel I. Vanag (2009-2013), Sergey Marchenkov (2011-current time)
 *
 * <b>Mail-list:</b> smartslog@cs.karelia.ru
 *
 * <br />
 *
 * @section LICENSE
 *
 * SmartSlog is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SmartSlog is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SmartSlog KP Library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 *
 * <b>Copyright 2009-2016 (C) PetrSU SmartSlog Team.
 * All rights reserved.</b> <br />
 */

#ifndef DESCRIPTION_H
#define	DESCRIPTION_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* DESCRIPTION_H */

