
#include "triple.h"
#include "triplestore.h"

#include <stdarg.h>
 #include <stddef.h>
 #include <setjmp.h>

#include "Basic.h"


static void null_test_success(void **state) {

//    sslog_triple_t *triple = sslog_store_create_triple("test-subject\0", "test-predicate", "test-object",
//                                                       SSLOG_RDF_TYPE_URI, SSLOG_RDF_TYPE_LIT);

//    assert_int_equal(3, 3);
//    assert_int_not_equal(3, 3);
}


static void test(void **state)
{
//    assert_int_equal(3, 1);
    //assert_int_not_equal(3, 3);
}

//int main(void) {
//    const UnitTest tests2[] = {
//        unit_test(null_test_success),
//    };

//    const UnitTest tests[] =
//       {
//           unit_test(test),
//       };
//       //return run_tests(tests);
//     return cmocka_run_group_tests(tests2, NULL, NULL);




//}



/* Pointer to the file used by the tests. */
static FILE* temp_file = NULL;

/* The suite initialization function.
 * Opens the temporary file used by the tests.
 * Returns zero on success, non-zero otherwise.
 */
int init_suite1(void)
{
   if (NULL == (temp_file = fopen("temp.txt", "w+"))) {
      return -1;
   }
   else {
      return 0;
   }
}

/* The suite cleanup function.
 * Closes the temporary file used by the tests.
 * Returns zero on success, non-zero otherwise.
 */
int clean_suite1(void)
{
   if (0 != fclose(temp_file)) {
      return -1;
   }
   else {
      temp_file = NULL;
      return 0;
   }
}

/* Simple test of fprintf().
 * Writes test data to the temporary file and checks
 * whether the expected number of bytes were written.
 */
void testFPRINTF(void)
{
   int i1 = 10;

   if (NULL != temp_file) {
      CU_ASSERT(0 == fprintf(temp_file, ""));
      CU_ASSERT(2 == fprintf(temp_file, "Q\n"));
      CU_ASSERT(7 == fprintf(temp_file, "i1 = %d", i1));
   }
}

/* Simple test of fread().
 * Reads the data previously written by testFPRINTF()
 * and checks whether the expected characters are present.
 * Must be run after testFPRINTF().
 */
void testFREAD(void)
{
   unsigned char buffer[20];

   if (NULL != temp_file) {
      rewind(temp_file);
      CU_ASSERT(9 == fread(buffer, sizeof(unsigned char), 20, temp_file));
      CU_ASSERT(0 == strncmp(buffer, "Q\ni1 = 10", 9));
   }
}
void testTripleNull()
{
    sslog_triple_t *triple = NULL;

    CU_ASSERT_PTR_NULL(sslog_triple_get_subject(triple));
    CU_ASSERT_PTR_NULL(sslog_triple_get_predicate(triple));
    CU_ASSERT_PTR_NULL(sslog_triple_get_object(triple));
    CU_ASSERT_EQUAL(sslog_triple_get_subject_type(triple), SSLOG_RDF_TYPE_INCORRECT);
    CU_ASSERT_EQUAL(sslog_triple_get_object_type(triple), SSLOG_RDF_TYPE_INCORRECT);
}



void testTriple()
{
    char *subject = "http://test.ru#TestTriple-1";
    char *subject_bnode = "http://test.ru#TestBnode-1";
    char *predicate = "http://test.ru#TestPredicate-1";
    char *object_uri = "http://test.ru#TestObject-1";
    char *object_bnode = "http://test.ru#TestBnode-2";
    char *object_lit = "data-1";

    sslog_triple_t *triple_uri = sslog_store_new_triple(subject, predicate, object_uri,
                                                       SSLOG_RDF_TYPE_URI, SSLOG_RDF_TYPE_URI);
    CU_ASSERT_PTR_NOT_NULL_FATAL(triple_uri);

    CU_ASSERT_STRING_EQUAL(sslog_triple_get_subject(triple_uri), subject);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_predicate(triple_uri), predicate);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_object(triple_uri), object_uri);
    CU_ASSERT_EQUAL(sslog_triple_get_subject_type(triple_uri), SSLOG_RDF_TYPE_URI);
    CU_ASSERT_EQUAL(sslog_triple_get_object_type(triple_uri), SSLOG_RDF_TYPE_URI);

    sslog_store_free_triple(triple_uri);


    sslog_triple_t *triple_lit = sslog_store_new_triple(subject, predicate, object_lit,
                                                       SSLOG_RDF_TYPE_URI, SSLOG_RDF_TYPE_LIT);
    CU_ASSERT_PTR_NOT_NULL_FATAL(triple_lit);

    CU_ASSERT_STRING_EQUAL(sslog_triple_get_subject(triple_lit), subject);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_predicate(triple_lit), predicate);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_object(triple_lit), object_lit);
    CU_ASSERT_EQUAL(sslog_triple_get_subject_type(triple_lit), SSLOG_RDF_TYPE_URI);
    CU_ASSERT_EQUAL(sslog_triple_get_object_type(triple_lit), SSLOG_RDF_TYPE_LIT);

    sslog_store_free_triple(triple_lit);


    sslog_triple_t *triple_bnode = sslog_store_new_triple(subject_bnode, predicate, object_bnode,
                                                       SSLOG_RDF_TYPE_BNODE, SSLOG_RDF_TYPE_BNODE);
    CU_ASSERT_PTR_NOT_NULL_FATAL(triple_lit);

    CU_ASSERT_STRING_EQUAL(sslog_triple_get_subject(triple_bnode), subject_bnode);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_predicate(triple_bnode), predicate);
    CU_ASSERT_STRING_EQUAL(sslog_triple_get_object(triple_bnode), object_bnode);
    CU_ASSERT_EQUAL(sslog_triple_get_subject_type(triple_bnode), SSLOG_RDF_TYPE_BNODE);
    CU_ASSERT_EQUAL(sslog_triple_get_object_type(triple_bnode), SSLOG_RDF_TYPE_BNODE);

    sslog_store_free_triple(triple_bnode);
}


/* The main() function for setting up and running the tests.
 * Returns a CUE_SUCCESS on successful running, another
 * CUnit error code on failure.
 */
int main()
{
   CU_pSuite pSuite = NULL;

   /* initialize the CUnit test registry */
   if (CUE_SUCCESS != CU_initialize_registry())
      return CU_get_error();

   /* add a suite to the registry */
   pSuite = CU_add_suite("Suite_1", init_suite1, clean_suite1);
   if (NULL == pSuite) {
      CU_cleanup_registry();
      return CU_get_error();
   }

   /* add the tests to the suite */
   /* NOTE - ORDER IS IMPORTANT - MUST TEST fread() AFTER fprintf() */
   if ((NULL == CU_add_test(pSuite, "test of fprintf()", testFPRINTF)) ||
       (NULL == CU_add_test(pSuite, "test of triples()", testTriple)) ||
       (NULL == CU_add_test(pSuite, "test of NULL triple", testTripleNull)) ||
       (NULL == CU_add_test(pSuite, "test of fread()", testFREAD)))
   {
      CU_cleanup_registry();
      return CU_get_error();
   }

   /* Run all tests using the CUnit Basic interface */
   CU_basic_set_mode(CU_BRM_VERBOSE);
   CU_basic_run_tests();

   int failed_tests = CU_get_number_of_tests_failed();

   CU_cleanup_registry();

   return failed_tests;
}
