﻿//  ------------------------------------------------------------------------
//  <copyright file="IHandlerConfig.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>02.02.2016 9:17</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------

using System.Collections.Generic;

namespace PetrSU.SmartSlog
{
    public interface IHandlerConfig
    {
  
        Individual Individual { get; }
        IList<Property> Properties { get; }
        object NewData { get; }
        object OldData { get; }
        void ToInsert(Individual individual, Property property, object data);
        void ToRemove(Individual individual, Property property, object data);
        void ToUpdate(Individual individual, Property property, object oldData, object newData);
    }
}
