﻿//  ------------------------------------------------------------------------
//  <copyright file="Constant.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>02.02.2016 9:17</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------
namespace PetrSU.SmartSlog
{
    internal static class Constant
    {
        /// <summary>
        /// Type of triple element.
        /// </summary>
        public const int SS_RDF_TYPE_URI = 1;

        /// <summary>
        /// Type of triple element.
        /// </summary>
        public const int SS_RDF_TYPE_LIT = 2;

        /// <summary>
        /// Type of triple element. Blank node.
        /// </summary>
        public const int SS_RDF_TYPE_BNODE = 3;

        /// <summary>
        /// Unboud type of variable in SPARQL request.
        /// </summary>
        public const int SS_RDF_TYPE_UNBOUND = 4;

        /// <summary>
        /// Maximum lenght of Node identifier.
        /// </summary>
        public const int SS_NODE_ID_MAX_LEN = 512;

        /// <summary>
        /// Maximum lenght of message.
        /// </summary>     
        public const int SS_MAX_MESSAGE_SIZE = 50000;

        /// <summary>
        /// Maximum lenght of IP address.
        /// </summary>
        public const int MAX_IP_LEN = 16;

        /// <summary>
        /// Maximum lenght of triplet ss_subject.
        /// </summary>
        public const int SS_SUBJECT_MAX_LEN = 1000;

        /// <summary>
        /// Maximum lenght of triplet ss_predicate.
        /// </summary>
        public const int SS_PREDICATE_MAX_LEN = 1000;

        /// <summary>
        /// Maximum lenght of triplet object.
        /// </summary>
        public const int SS_OBJECT_MAX_LEN = 1000;

        /// <summary>
        /// Maximum lenght of RDF type.
        /// </summary>
        public const int SS_RDF_TYPE_MAX_LEN = 8;

        /// <summary>
        /// Maximum lenght of URI.
        /// </summary>
        public const int SS_URI_MAX_LEN = 100;

        /// <summary>
        /// Maximum lenght of space identifier.
        /// </summary>
        public const int SS_SPACE_ID_MAX_LEN = 512;

        /// <summary>
        /// /// Maximum lenght of subscribe identifier.
        /// </summary>
        public const int SS_SUB_ID_MAX_LEN = 512;

        /// <summary>
        /// Any URI, means any element.
        /// </summary>
        public const string SS_RDF_SIB_ANY = "http://www.nokia.com/NRC/M3/sib#any";

        /// <summary>
        /// Default space identifier.
        /// </summary>
        public const string SPACE_ID = "X";

        /// <summary>
        /// This subscription status means that new data received from the smart space.
        /// </summary>
        public const int SUBS_STATUS_INDICATION = 1;

        /// <summary>
        /// This subscription status means something wrong is happend while subscription process.
        /// </summary>
        public const int SUBS_STATUS_ERROR = -1;

        /// <summary>
        /// This subscription status means that new data has not been received for the given time.
        /// </summary>
        public const int SUBS_STATUS_TIMEOUT = 0;

        /// <summary>
        /// This subscription status come when the smart space  unsubscribes a subscription.
        /// </summary>
        public const int SUBS_STATUS_UNSUBSCRIBED = 2;


        public const int SSLOG_NETWORK_ERROR_START = 400;

        public const int SSLOG_NETWORK_ERROR_END = 500;

        public const int SSLOG_ERROR_NO = 0;
    }

  
}
