﻿//  ------------------------------------------------------------------------
//  <copyright file="sslog_entity.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>17.05.2016 13:53</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------

using System;

namespace PetrSU.SmartSlog
{       
    /**
         * @brief Base structure of entity: class, property or individual.
         */
    //struct sslog_entity_s
    //{
    //    sslog_entity_type type;         /**< Type of the entity: class, property or individual. */
    //    char* uri;                      /**< URI of class. */
    //    sslog_triple_t* linked_triple;  /**< Linked triple for entity */
    //};
    /**
     * @brief Class structure.
     */
    //struct sslog_class_s
    //{
    //    sslog_entity_t entity;      /**< Base structure of entity */
    //    // list_t *superclasses;   /**< List of superclasses. */
    //    list_t* properties;         /**< Properties list for class. */
    //};



    

    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_entity
    {
        /** @brief Types of entities. */
        //typedef enum sslog_entity_type_e {
        //    SSLOG_ENTITY_UNKNOWN = -1,      /**< Error type */
        //    SSLOG_ENTITY_INDIVIDUAL = 1,    /**< Individual type. */
        //    SSLOG_ENTITY_CLASS,             /**< Class type. */
        //    SSLOG_ENTITY_PROPERTY           /**< Property type. */
        //} sslog_entity_type;
        //    sslog_entity_type type;         /**< Type of the entity: class, property or individual. */
        public int type;

        //    char* uri;                      /**< URI of class. */
        //[System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        //public string uri;
        public IntPtr uri;      

        //    sslog_triple_t* linked_triple;  /**< Linked triple for entity */
        public IntPtr linked_triple;      
    }

    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_class
    {
        //    sslog_entity_t entity;      /**< Base structure of entity */
        public int type;

        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string uri;

        public IntPtr linked_triple;    

        //    // list_t *superclasses;   /**< List of superclasses. */
        public IntPtr superclasses;

        //    list_t* properties;         /**< Properties list for class. */
        public IntPtr properties;
    }

    ///**
    // * @brief Individual structure.
    // */
    //struct sslog_individual_s
    //{
    //    sslog_entity_t entity;      /**< Base structure of entity */
    //    char* class_uri;            /**< Individual's class uri. */
    //};
    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_individual
    {
        //    sslog_entity_t entity;      /**< Base structure of entity */
        public int type;

        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string uri;

        public IntPtr linked_triple;    

        //    char* class_uri;            /**< Individual's class uri. */
        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string class_uri;

    }


    /**
     * @brief Property structure.
     */
    //struct sslog_property_s
    //{
    //    sslog_entity_t entity;  /**< Base structure of entity */
    //    char* domain;           /**< Property domain. */
    //    int mincardinality;     /**< Minimal cardinality. */
    //    int maxcardinality;     /**< Maximum cardinality. */
    //    sslog_property_type type;    /**< Type of property: literal (data) or object. */
    //};

    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_property_s
    {
        //    sslog_entity_t entity;      /**< Base structure of entity */
        //    sslog_entity_t entity;      /**< Base structure of entity */
        public int type;

        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string uri;

        public IntPtr linked_triple;    

        //char* domain;    /**< Property domain. */
        public IntPtr domain;

        //     int mincardinality;        /**< Minimal cardinality. */
        public int mincardinality;

        //    int maxcardinality;     /**< Maximum cardinality. */
        public int maxcardinality;

        
        /**
         * @brief Property types.
         * Property can be data or object.
         * Data property links individual with some raw data (value of color, years, number of weeks and etc.).
         * Object property links individual with other individuals.
         */
        //typedef enum sslog_property_type_enum {
        //    SSLOG_PROPERTY_TYPE_OBJECT = SSLOG_RDF_TYPE_URI,  = 1  /**< Object-type property. */
        //    SSLOG_PROPERTY_TYPE_DATA = SSLOG_RDF_TYPE_LIT     = 2  /**< Data-type property. */
        //} sslog_property_type;
        //    sslog_property_type type;    /**< Type of property: literal (data) or object. */
        public int property_type;
    }
}
