﻿//  ------------------------------------------------------------------------
//  <copyright file="sslog_sparql_result.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>28.02.2016 20:54</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------

using System;

namespace PetrSU.SmartSlog.NativeStructures
{
    //    typedef struct sslog_sparql_result_s
    //{
    //  int bindings_count;                   /**< Number of binding variables in the result (columns). */
    //  int rows_count;                       /**< Number of rows in the result. */
    //  char **names;                         /**< Names of the binding variable (columns names). */
    //  sslog_sparql_result_row_t **rows;     /**< Rows with result data. */
    //} sslog_sparql_result_t;

    //    typedef struct sslog_sparql_result_row_s
    //{
    //    int *types;                        /**< Value type of the binding variable. */
    //    char **values;                     /**< Value of the binding variable. */

    //} sslog_sparql_result_row_t;
    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_sparql_result
    {
        public int bindings_count;                   /**< Number of binding variables in the result (columns). */
        public int rows_count;                       /**< Number of rows in the result. */

        ///// char **names;
        public IntPtr names;                       /**< Names of the binding variable (columns names). */

        ///// sslog_sparql_result_row_t **rows;
        //[System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.ByValArray)]
        public IntPtr rows;       /**< Rows with result data. */
    }

    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_sparql_result_row
    {
        public IntPtr types;                                  /**< Value type of the binding variable. */
        
        public IntPtr values;                             /**< Value of the binding variable. */
    }


}
