﻿//  ------------------------------------------------------------------------
//  <copyright file="sslog_triple.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>02.02.2016 9:17</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------
namespace PetrSU.SmartSlog
{
    /// <summary>
    /// Struct contains RDF format triple.
    /// The triples consist of subject, predicate and object. The subject can have type SS_RDF_TYPE_URI or SS_RDF_TYPE_BNODE. Possible types for object are SS_RDF_TYPE_URI,
    /// SS_RDF_TYPE_BNODE or SS_RDF_TYPE_LIT.
    /// </summary>
    //[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    //internal struct sslog_triple
    //{
    //    /// <summary>
    //    /// Triple ss_subject.
    //    /// </summary>
    //    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = Constant.SS_SUBJECT_MAX_LEN)]
    //    public string subject;

    //    /// <summary>
    //    /// Triple ss_predicate.
    //    /// </summary>
    //    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = Constant.SS_PREDICATE_MAX_LEN)]
    //    public string predicate;

    //    /// <summary>
    //    /// Triple object.
    //    /// </summary>
    //    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = Constant.SS_OBJECT_MAX_LEN)]
    //    public string object_;

    //    /// <summary>
    //    /// The type of the subject.
    //    /// </summary>
    //    public int subject_type;

    //    /// <summary>
    //    /// The type of the object.
    //    /// </summary>
    //    public int object_type;
    //}


    [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
    public struct sslog_triple
    {

        /// char*
        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string subject;

        /// char*
        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string predicate;

        /// char*
        [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)]
        public string @object;

        /// int
        public int subject_type;

        /// int
        public int object_type;
    }
}
