﻿//  ------------------------------------------------------------------------
//  <copyright file="OwlMapping.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>02.02.2016 9:17</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------

using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace PetrSU.SmartSlog
{
    // TODO: add checking of properties and values
    internal class OwlMapping
    {



        public static List<ITriple> IndividualToTriples(IKpi kpi, Individual ind)
        {
            List<ITriple> triples = new List<ITriple>();
            Individual objValue;

            //triples.Add(kpi.CreateTriple(ind.Uri, kpi.RdfTypeUri, ind.ParentClass.Uri, RdfType.Uri, RdfType.Uri));

            foreach (PropertyValue value in ind.GetPropertiesValues())
            {
                ITriple triple = null;
                if (value.Property.IsObject())
                {
                    objValue = value.GetObjectValue();

                    //triple = kpi.CreateTriple(ind.Uri, value.Property.Uri, objValue.Uri, RdfType.Uri, RdfType.Uri);
                }
                else
                {
                    //triple = kpi.CreateTriple(ind.Uri, value.Property.Uri, value.GetDataValue(), RdfType.Uri, RdfType.Literal);
                }
                triples.Add(triple);
            }

            return triples;
        }

        public static List<ITriple> IndividualToTriplesAny(IKpi kpi, Individual ind)
        {
            List<ITriple> triples = new List<ITriple>()
            {
                //kpi.CreateTriple(ind.Uri, kpi.RdfTypeUri, ind.ParentClass.Uri, RdfType.Uri,RdfType.Uri)
            };

            foreach (Property value in ind.ParentClass.GetProperties())
            {
                if (value.IsObject())
                {
                    //triples.Add(kpi.CreateTriple(ind.Uri, value.Uri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));
                }
                else
                {
                    //triples.Add(kpi.CreateTriple(ind.Uri, value.Uri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));
                }
            }

            return triples;
        }

        public static List<ITriple> IndividualToAnyAny(IKpi kpi, Individual ind)
        {
            List<ITriple> triples = new List<ITriple>()
            {
                //kpi.CreateTriple(ind.Uri, kpi.AnyUri, kpi.AnyUri, RdfType.Uri, RdfType.Uri)
        };
            return triples;
        }

       



        public static List<ITriple> ClassToTriples(IKpi kpi, OntologyClass oClass)
        {
            List<ITriple> triples = new List<ITriple>();

            //if (individual.GetProperties())
            //{
            foreach (Property value in oClass.GetProperties())
            {
                if (value.IsObject())
                {
                    //triples.Add(kpi.CreateTriple(kpi.AnyUri, value.Uri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));
                }
                else
                {
                    //triples.Add(kpi.CreateTriple(kpi.AnyUri, value.Uri, kpi.AnyUri, RdfType.Uri, RdfType.Literal));
                }
            }
            //}
            //else set_error(ERROR_CANT_FIND_PROPERTY);

            return triples;
        }


        // TODO: optimize: call createIndividualIgnore with ontology class object
        public static Collection<Individual> TripplesToIndividuals(IKpi kpi, IRepository rep, ICollection<ITriple> triples)
        {
            Collection<Individual> inds = new Collection<Individual>();

            //ITriple ITriple = ITriples;
            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate == kpi.RdfTypeUri)
                //{
                //    Individual ind = createIndividualIgnore(rep, triple.Subject, triple.ObjectElement);
                //    if (ind == null) continue;

                //    if (!inds.Contains(ind))
                //    {
                //        inds.Add(ind);
                //    }
                //}
            }

            //ITriple = ITriples;
            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate != kpi.RdfTypeUri)
                //{
                //    Individual ind = rep.GetIndividual(triple.Subject);
                //    if (ind == null)
                //    {
                //        continue;
                //    }
                //    else
                //    {
                //        Property property = rep.GetPropertyByUri(triple.Predicate);
                //        if (property == null) continue;

                //        if (property.IsObject())
                //        {
                //            Individual indRef = rep.GetIndividual(triple.ObjectElement);
                //            if (indRef == null)
                //            {
                //                //TODO request for a class to SS
                //                List<ITriple> requestedTriples = new List<ITriple>();
                //                List<ITriple> resultTriples = new List<ITriple>();

                //                //requestedTriples.Add(kpi.CreateTriple(triple.ObjectElement, kpi.RdfTypeUri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));

                //                try
                //                {
                //                    //kpi.Query(requestedTriples, resultTriples);
                //                }
                //                catch (Exception e)
                //                {
                //                    Debug.WriteLine("TripplesToIndividuals: " + e.Message);
                //                    continue;
                //                }

                //                if ((resultTriples == null) || (resultTriples.Count == 0))
                //                {
                //                    continue;
                //                }
                //                OntologyClass ontClass = rep.GetClassByUri(resultTriples[0].ObjectElement);
                //                if (ontClass == null)
                //                {
                //                    continue;
                //                }
                                
                //                indRef = rep.CreateIndividual(ontClass, triple.ObjectElement);
                //            }
                //            ind.RemoveProperty(property, indRef);
                //            ind.SetProperty(property, indRef);
                //        }
                //        else
                //        {
                //            ind.RemoveProperty(property, triple.ObjectElement);
                //            ind.SetProperty(property, triple.ObjectElement);
                //        }
                //    }
                //}
            }

            return inds;
        }


        // TODO: get class for object property
        public static Individual TripplesToIndividualOne(IKpi kpi, IRepository repository, ICollection<ITriple> triples)
        {
            Individual ind = null;

            Dictionary<string, OntologyClass> classes = GetObjectPropertiesClasses(kpi, repository, triples);

            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate == kpi.RdfTypeUri)
                //{
                //    ind = createIndividualIgnore(repository, triple.Subject, triple.ObjectElement);
                //    if (ind != null)
                //    {
                //        break;
                //    }
                //}
            }

            if (ind == null)
            {
                return null;
            }

            foreach (ITriple triple in triples)
            {
                //if ((triple.Predicate != kpi.RdfTypeUri) && (triple.Subject == ind.Uri))
                //{
                //    Property property = repository.GetPropertyByUri(triple.Predicate);
                //    if (property == null) return null;

                //    if (property.IsObject())
                //    {
                //        OntologyClass ontologyClass = classes[triple.ObjectElement];
                //        //Individual indRef = repository.GetIndividualByUUID(triple.ObjectElement);
                //        Individual indRef = repository.GetOrCreateIndividual(ontologyClass, triple.ObjectElement);
                //        ind.SetProperty(property, indRef);
                //    }
                //    else
                //    {
                //        ind.SetProperty(property, triple.ObjectElement);
                //    }
                //}
            }

            return ind;
        }

        // TODO: optimize: call createIndividualIgnore with ontologe class object
        public Individual TripplesToIndividual(IKpi kpi, IRepository rep, List<ITriple> triples)
        {
            List<Individual> inds = new List<Individual>();

            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate == kpi.RdfTypeUri)
                //{
                //    Individual ind = createIndividualIgnore(rep, triple.Subject, triple.ObjectElement);
                //    if (!inds.Contains(ind))
                //    {
                //        inds.Add(ind);
                //    }
                //}
                //else
                //{
                //    Property property = rep.GetPropertyByUri(triple.Predicate);
                //    if (property.IsObject())
                //    {
                //        createIndividualIgnore(rep, triple.ObjectElement, property.Uri);
                //    }
                //}
            }

            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate != kpi.RdfTypeUri)
                //{
                //    Individual ind = rep.GetIndividual(triple.Subject);
                //    if (ind == null)
                //    {
                //        continue;
                //    }
                //    else
                //    {
                //        Property property = rep.GetPropertyByUri(triple.Predicate);
                //        if (property.IsObject())
                //        {
                //            Individual indRef = rep.GetIndividual(triple.ObjectElement);
                //            ind.SetProperty(property, indRef);
                //        }
                //        else
                //        {
                //            ind.SetProperty(property, triple.ObjectElement);
                //        }
                //    }
                //}

            }

            return inds[0];
        }


        public static Individual createIndividualIgnore(IRepository rep, string uuid, string ontClassName)
        {
            Individual ind = rep.GetIndividual(uuid);
            if (ind == null)
            {
                OntologyClass ontClass = rep.GetClassByUri(ontClassName);
                if (ontClass == null)
                {
                    return ind;
                }
                else
                {
                    ind = rep.CreateIndividual(ontClass, uuid);
                }
            }
            return ind;
        }


        internal static List<ITriple> IndividualToTriplesAny(IKpi kpi, Individual individual, List<Property> properties)
        {
            List<ITriple> triples = new List<ITriple>();

            foreach (Property property in properties)
            {
                RdfType propertyType = (property.IsObject() == true) ? RdfType.Uri : RdfType.Literal;

                //ITriple ITriple = kpi.CreateTriple(individual.Uri, property.Uri, kpi.AnyUri,
                  //  RdfType.Uri, propertyType);

                //triples.Add(ITriple);
            }

            return triples;
        }

        internal static void IndividualToTriplesAny(IKpi kpi, Individual individual, ICollection<Property> properties, ICollection<ITriple> triples)
        {
            foreach (Property property in properties)
            {
                //triples.Add(kpi.CreateTriple(individual.Uri, property.Uri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));
            }
        }

        //internal static void PropertyToTriplesInsert(IKpi kpi, Individual individual, Property property, Individual value, ICollection<ITriple> triples)
        //{
        //    ITriple triple = kpi.CreateTriple(individual.Uri, property.Uri, value.Uri, RdfType.Uri, RdfType.Uri);
        //    triples.Add(triple);

        //    triple = kpi.CreateTriple(value.Uri, kpi.RdfTypeUri, value.ParentClass.Uri, RdfType.Uri, RdfType.Uri);
        //    triples.Add(triple);
        //}

        //internal static void PropertyToTriplesInsert(IKpi kpi, Individual individual, Property property, string value, ICollection<ITriple> triples)
        //{
        //    ITriple triple = kpi.CreateTriple(individual.Uri, property.Uri, value, RdfType.Uri, RdfType.Literal);
        //    triples.Add(triple);
        //}

        //internal static void PropertyToTriplesInsert(IKpi kpi, Individual individual, Property property, object value, ICollection<ITriple> triples)
        //{
        //    if (property.IsObject())
        //    {
        //        PropertyToTriplesInsert(kpi, individual, property, value as Individual, triples);
        //    }
        //    else
        //    {
        //        PropertyToTriplesInsert(kpi, individual, property, value as string, triples);
        //    }

        //}

        //internal static void PropertyToTriplesRemove(IKpi kpi, Individual individual, Property property, object value, ICollection<ITriple> triples)
        //{
        //    if (property.IsObject() == true)
        //    {
        //        PropertyToTriplesRemove(kpi, individual, property, value as Individual, triples);
        //    }
        //    else
        //    {
        //        PropertyToTriplesRemove(kpi, individual, property, value as string, triples);
        //    }
        //}

        //internal static void PropertyToTriplesRemove(IKpi kpi, Individual individual, Property property, Individual value, ICollection<ITriple> triples)
        //{
        //    triples.Add(kpi.CreateTriple(individual.Uri, property.Uri, (value as Individual).Uri, RdfType.Uri, RdfType.Uri));
        //}

        //internal static void PropertyToTriplesRemove(IKpi kpi, Individual individual, Property property, string value, ICollection<ITriple> triples)
        //{
        //    triples.Add(kpi.CreateTriple(individual.Uri, property.Uri, value, RdfType.Uri, RdfType.Literal));
        //}


        internal static void PropertyToTriples(IKpi kpi, Individual individual, Property property, Individual value, ICollection<ITriple> triples)
        {
            //triples.Add(kpi.CreateTriple(individual.Uri, property.Uri, (value as Individual).Uri, RdfType.Uri, RdfType.Uri));
        }

        internal static void PropertyToTriples(IKpi kpi, Individual individual, Property property, string value, ICollection<ITriple> triples)
        {
            //triples.Add(kpi.CreateTriple(individual.Uri, property.Uri, value, RdfType.Uri, RdfType.Literal));
        }

        internal static void PropertyToTriples(IKpi kpi, Individual individual, Property property, object value, ICollection<ITriple> triples)
        {
            if (property.IsObject() == true)
            {
                PropertyToTriples(kpi, individual, property, value as Individual, triples);
            }
            else
            {
                PropertyToTriples(kpi, individual, property, value as string, triples);
            }
        }


        internal static ITriple GetRdfTypeTriple(IKpi kpi, Individual individual)
        {
            return null;
            //return kpi.CreateTriple(individual.Uri, kpi.RdfTypeUri, individual.ParentClass.Uri, RdfType.Uri, RdfType.Uri);
        }

        /// <summary>
        /// Gets ontology class for given uuid from smart space.
        /// <seealso cref="PetrSU.SmartSlog.OntologyClass"/>
        /// <seealso cref="PetrSU.SmartSlog.Individual"/>
        /// </summary>
        /// <remarks>
        /// Try to gets triple from SmartSpace that represents given RDF_TYPE ontology class for individual with given uuid.
        /// If RDF_TYPE not defined in SS null would be returned.
        /// </remarks>
        /// <param name="uuid">Individuals uuid.</param>
        /// <returns>OntologyClass if RDF_TYPE is defined in SS, null otherwise.</returns>
        /// <seealso cref="PetrSU.SmartSlog.OntologyClass"/>
        internal static OntologyClass GetClassByUuid(IKpi kpi, IRepository repository, string uuid)
        {
            List<ITriple> requestTriples = new List<ITriple>();
            List<ITriple> resultTriples = new List<ITriple>();

            //requestTriples.Add(kpi.CreateTriple(uuid, kpi.RdfTypeUri, kpi.AnyUri, RdfType.Uri, RdfType.Uri));

            try
            {
                //KpiHelper.DoKpi(kpi.Query, requestTriples, resultTriples, LoggerManager.OwlMappingManagement, "GetClassByUuid");
            }
            catch
            {
                LoggerManager.WriteMessage(LoggerManager.OwlMappingManagement, "GetClassByUuid", "Class with UUID='" + uuid + "cannot be received.");
            }

            if (resultTriples.Count > 0)
            {
                string classType = resultTriples[0].ObjectElement;
                return repository.GetClassByUri(classType);
            }

            return null;
        }

        internal static void ClassToTriplesSubscription(IKpi kpi, OntologyClass ontologyClass, ICollection<ITriple> triples)
        {
            //triples.Add(new Triple(kpi.AnyUri, kpi.RdfTypeUri, ontologyClass.Uri, RdfType.Uri, RdfType.Uri));
        }

        internal static void SubscriptionToTriples(IKpi kpi, Subscription subscription, ICollection<ITriple> triples)
        {
            foreach (SubscriptionData sd in subscription.GetData())
            {
                //OwlMapping.IndividualToTriplesAny(kpi, sd.Individual, sd.Properties, triples);
            }

            //// Triples for classes: <*> - <rdf:type> - <class-uri>
            foreach (OntologyClass oc in subscription.GetClasses())
            {
                OwlMapping.ClassToTriplesSubscription(kpi, oc, triples);
            }
        }

        private static Dictionary<string, OntologyClass> GetObjectPropertiesClasses(IKpi kpi, IRepository repository, ICollection<ITriple> triples)
        {
            Debug.Assert(triples != null);

            Dictionary<string, OntologyClass> classtypes = new Dictionary<string, OntologyClass>();

            foreach (ITriple triple in triples)
            {
                //if (triple.Predicate != kpi.RdfTypeUri)
                //{
                //    Property property = repository.GetPropertyByUri(triple.Predicate);
                //    if (property == null)
                //    {
                //        continue;
                //    }

                //    if (property.IsObject() == true)
                //    {
                //        OntologyClass ontologyClass = OwlMapping.GetClassByUuid(kpi, repository, triple.ObjectElement);

                //        if (ontologyClass != null)
                //        {
                //            classtypes.Add(triple.ObjectElement, ontologyClass);
                //        }
                //    }
                //}
            }
            return classtypes;
        }

        
    }
}
