﻿//  ------------------------------------------------------------------------
//  <copyright file="SemanticException.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>02.02.2016 9:17</created>
//  <lastedit>05.07.2016 14:39</lastedit>
//  ------------------------------------------------------------------------

using System;
using System.Runtime.Serialization;

namespace PetrSU.SmartSlog
{
    public class SemanticException : Exception
    {
        /// <summary>
        ///  Initializes a new instance of the KpiException class.
        /// </summary>
        public SemanticException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the KpiException class with a specified error message.
        /// </summary>
        /// <param name="message">The message that describes the error.</param>
        public SemanticException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the KpiException class with a specified
        /// error message and a reference to the inner exception that is the cause of
        /// this exception.
        /// </summary>
        /// <param name="message">The error message that explains the reason for the exception.</param>
        /// <param name="inner">The exception that is the cause of the current exception, or a null reference 
        /// (Nothing in Visual Basic) if no inner exception is specified.</param>
        public SemanticException(string message, Exception inner)
            : base(message, inner)
        {
        }

#if !(PORTABLE || WINDOWS_PHONE) 
        /// <summary>
        /// Initializes a new instance of the KpiException class with the specified serialization information and context.
        /// </summary>
        /// <param name="info">The SerializationInfo that holds the serialized object data about the exception being thrown.</param>
        /// <param name="context">The StreamingContext that contains contextual information about the source or destination.</param>
        protected SemanticException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
#endif
    }
}
