//  ------------------------------------------------------------------------
//  <copyright file="DrinkersOntologyStructure.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>22.06.2016 11:24</created>
//  <lastedit>05.07.2016 14:38</lastedit>
//  ------------------------------------------------------------------------
#define INCLUDE_PROPERTY_LNAME
#define INCLUDE_PROPERTY_SENDER
#define INCLUDE_PROPERTY_FROM
#define INCLUDE_PROPERTY_SID
#define INCLUDE_PROPERTY_CONTENT
#define INCLUDE_PROPERTY_RECEIVER_ID
#define INCLUDE_PROPERTY_NUMBER_OF_DRINKS
#define INCLUDE_PROPERTY_ARRIVALTIME
#define INCLUDE_PROPERTY_FNAME
#define INCLUDE_PROPERTY_TO
#define INCLUDE_PROPERTY_DRINKS
#define INCLUDE_CLASS_HUMAN
#define INCLUDE_CLASS_GIRL
#define INCLUDE_CLASS_MAN
#define INCLUDE_CLASS_MESSAGE
#define INCLUDE_CLASS_MILK
//#define INCLUDE_CLASS_NOTHING
#define INCLUDE_CLASS_WATER
#define INCLUDE_CLASS_BEER
#define INCLUDE_CLASS_BEVERAGE
#define INCLUDE_CLASS_EMAIL
//#define INCLUDE_CLASS_THING
#define INCLUDE_CLASS_SMS
#define INCLUDE_CLASS_BOY
#define INCLUDE_CLASS_WOMAN

using System.Collections.Generic;

namespace PetrSU.SmartSlog.Demo.Drinkers
{
    // Add a reference

    public static class OntologyStructure
    {
        static OntologyStructure()
        {
            List<Property> properties = new List<Property>();
            List<OntologyClass> superclasses = new List<OntologyClass>();

#if INCLUDE_PROPERTY_LNAME
            Lname = new Property("http://www.m3.com/2008/02/m3/canonical#lname",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_SENDER
            Sender = new Property("http://sofia.org/msg#sender",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_FROM
            From = new Property("http://sofia.org/msg#from",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_SID
            Sid = new Property("http://sofia.org/msg#sid",
                maxCardinality: -1, minCardinality: -1,
                isObject: true);
#endif
#if INCLUDE_PROPERTY_CONTENT
            Content = new Property("http://sofia.org/msg#content",
                maxCardinality: -1, minCardinality: -1,
                isObject: true);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            Receiverid = new Property("http://sofia.org/msg#receiver_id",
                maxCardinality: -1, minCardinality: -1,
                isObject: true);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            Numberofdrinks = new Property("http://www.m3.com/2008/02/m3/canonical#number_of_drinks",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            Arrivaltime = new Property("http://sofia.org/msg#arrivaltime",
                maxCardinality: -1, minCardinality: -1,
                isObject: true);
#endif
#if INCLUDE_PROPERTY_FNAME
            Fname = new Property("http://www.m3.com/2008/02/m3/canonical#fname",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_TO
            To = new Property("http://sofia.org/msg#to",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif
#if INCLUDE_PROPERTY_DRINKS
            Drinks = new Property("#http://www.m3.com/2008/02/m3/canonical#drinks",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif




#if INCLUDE_CLASS_HUMAN
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_HUMAN
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Human = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Human", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_GIRL
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_GIRL
#if INCLUDE_CLASS_HUMAN
            superclasses.Add(Human);
#endif
#endif

        Girl = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Girl", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_MAN
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_MAN
#if INCLUDE_CLASS_HUMAN
            superclasses.Add(Human);
#endif
#endif

        Man = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Man", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_MESSAGE
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_MESSAGE
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Message = new OntologyClass("http://sofia.org/msg#Message", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_MILK
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_MILK
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Milk = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Milk", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_GIRL
            superclasses.Add(Girl);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_MAN
            superclasses.Add(Man);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_MESSAGE
            superclasses.Add(Message);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_MILK
            superclasses.Add(Milk);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_BEVERAGE
            superclasses.Add(Beverage);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_EMAIL
            superclasses.Add(Email);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_WATER
            superclasses.Add(Water);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_BEER
            superclasses.Add(Beer);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_SMS
            superclasses.Add(SMS);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_BOY
            superclasses.Add(Boy);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_WOMAN
            superclasses.Add(Woman);
#endif
#endif

        Nothing = new OntologyClass("http://www.w3.org/2002/07/owl#Nothing", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_WATER
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_WATER
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Water = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Water", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_BEER
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_BEER
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Beer = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Beer", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_BEVERAGE
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_BEVERAGE
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Beverage = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Beverage", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_EMAIL
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_EMAIL
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        Email = new OntologyClass("http://sofia.org/msg#Email", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_THING
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif


        Thing = new OntologyClass("http://www.w3.org/2002/07/owl#Thing", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_SMS
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_SMS
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

        SMS = new OntologyClass("http://sofia.org/msg#SMS", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_BOY
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_BOY
#if INCLUDE_CLASS_HUMAN
            superclasses.Add(Human);
#endif
#endif

        Boy = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Boy", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_WOMAN
#if INCLUDE_PROPERTY_SID
            properties.Add(Sid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            properties.Add(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_FROM
            properties.Add(From);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            properties.Add(Receiverid);
#endif
#if INCLUDE_PROPERTY_FNAME
            properties.Add(Fname);
#endif
#if INCLUDE_PROPERTY_CONTENT
            properties.Add(Content);
#endif
#if INCLUDE_PROPERTY_DRINKS
            properties.Add(Drinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            properties.Add(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_TO
            properties.Add(To);
#endif
#if INCLUDE_PROPERTY_SENDER
            properties.Add(Sender);
#endif
#if INCLUDE_PROPERTY_LNAME
            properties.Add(Lname);
#endif

#if INCLUDE_CLASS_WOMAN
#if INCLUDE_CLASS_HUMAN
            superclasses.Add(Human);
#endif
#endif

        Woman = new OntologyClass("http://www.m3.com/2008/02/m3/canonical#Woman", properties, superclasses);
        properties = new List<Property>();
        superclasses = new List<OntologyClass>();
#endif



        }

#if INCLUDE_CLASS_HUMAN
        public static OntologyClass Human {get; private set;}
#endif
#if INCLUDE_CLASS_GIRL
        public static OntologyClass Girl {get; private set;}
#endif
#if INCLUDE_CLASS_MAN
        public static OntologyClass Man {get; private set;}
#endif
#if INCLUDE_CLASS_MESSAGE
        public static OntologyClass Message {get; private set;}
#endif
#if INCLUDE_CLASS_MILK
        public static OntologyClass Milk {get; private set;}
#endif
#if INCLUDE_CLASS_NOTHING
        public static OntologyClass Nothing {get; private set;}
#endif
#if INCLUDE_CLASS_WATER
        public static OntologyClass Water {get; private set;}
#endif
#if INCLUDE_CLASS_BEER
        public static OntologyClass Beer {get; private set;}
#endif
#if INCLUDE_CLASS_BEVERAGE
        public static OntologyClass Beverage {get; private set;}
#endif
#if INCLUDE_CLASS_EMAIL
        public static OntologyClass Email {get; private set;}
#endif
#if INCLUDE_CLASS_THING
        public static OntologyClass Thing {get; private set;}
#endif
#if INCLUDE_CLASS_SMS
        public static OntologyClass SMS {get; private set;}
#endif
#if INCLUDE_CLASS_BOY
        public static OntologyClass Boy {get; private set;}
#endif
#if INCLUDE_CLASS_WOMAN
        public static OntologyClass Woman {get; private set;}
#endif


#if INCLUDE_PROPERTY_LNAME
       public static Property Lname {get; private set;}
#endif
#if INCLUDE_PROPERTY_SENDER
       public static Property Sender {get; private set;}
#endif
#if INCLUDE_PROPERTY_FROM
       public static Property From {get; private set;}
#endif
#if INCLUDE_PROPERTY_SID
       public static Property Sid {get; private set;}
#endif
#if INCLUDE_PROPERTY_CONTENT
       public static Property Content {get; private set;}
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
       public static Property Receiverid {get; private set;}
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
       public static Property Numberofdrinks {get; private set;}
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
       public static Property Arrivaltime {get; private set;}
#endif
#if INCLUDE_PROPERTY_FNAME
       public static Property Fname {get; private set;}
#endif
#if INCLUDE_PROPERTY_TO
       public static Property To {get; private set;}
#endif
#if INCLUDE_PROPERTY_DRINKS
       public static Property Drinks {get; private set;}
#endif


       public static void RegisterOntology(Node node)
        {
            if (node == null)
            {
                throw new System.ArgumentNullException("node");
            }
            
            RegisterOntology(node.Session);
        }    

        public static void RegisterOntology(ISession registrator)
        {
            if (registrator == null)
            {
                throw new System.ArgumentNullException("registrator");
            }

#if INCLUDE_PROPERTY_LNAME
            registrator.RegisterEntity(Lname);
#endif
#if INCLUDE_PROPERTY_SENDER
            registrator.RegisterEntity(Sender);
#endif
#if INCLUDE_PROPERTY_FROM
            registrator.RegisterEntity(From);
#endif
#if INCLUDE_PROPERTY_SID
            registrator.RegisterEntity(Sid);
#endif
#if INCLUDE_PROPERTY_CONTENT
            registrator.RegisterEntity(Content);
#endif
#if INCLUDE_PROPERTY_RECEIVER_ID
            registrator.RegisterEntity(Receiverid);
#endif
#if INCLUDE_PROPERTY_NUMBER_OF_DRINKS
            registrator.RegisterEntity(Numberofdrinks);
#endif
#if INCLUDE_PROPERTY_ARRIVALTIME
            registrator.RegisterEntity(Arrivaltime);
#endif
#if INCLUDE_PROPERTY_FNAME
            registrator.RegisterEntity(Fname);
#endif
#if INCLUDE_PROPERTY_TO
            registrator.RegisterEntity(To);
#endif
#if INCLUDE_PROPERTY_DRINKS
            registrator.RegisterEntity(Drinks);
#endif




#if INCLUDE_CLASS_HUMAN
        registrator.RegisterEntity(Human);
#endif
#if INCLUDE_CLASS_GIRL
        registrator.RegisterEntity(Girl);
#endif
#if INCLUDE_CLASS_MAN
        registrator.RegisterEntity(Man);
#endif
#if INCLUDE_CLASS_MESSAGE
        registrator.RegisterEntity(Message);
#endif
#if INCLUDE_CLASS_MILK
        registrator.RegisterEntity(Milk);
#endif
#if INCLUDE_CLASS_NOTHING
        registrator.RegisterEntity(Nothing);
#endif
#if INCLUDE_CLASS_WATER
        registrator.RegisterEntity(Water);
#endif
#if INCLUDE_CLASS_BEER
        registrator.RegisterEntity(Beer);
#endif
#if INCLUDE_CLASS_BEVERAGE
        registrator.RegisterEntity(Beverage);
#endif
#if INCLUDE_CLASS_EMAIL
        registrator.RegisterEntity(Email);
#endif
#if INCLUDE_CLASS_THING
        registrator.RegisterEntity(Thing);
#endif
#if INCLUDE_CLASS_SMS
        registrator.RegisterEntity(SMS);
#endif
#if INCLUDE_CLASS_BOY
        registrator.RegisterEntity(Boy);
#endif
#if INCLUDE_CLASS_WOMAN
        registrator.RegisterEntity(Woman);
#endif



        }
    }
}

