//  ------------------------------------------------------------------------
//  <copyright file="HelloOntologyStructureStatic.cs" company="PetrSU">
//  SmartSlog Library is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License as 
//  published by the Free Software Foundation; either version 2 of 
//  the License, or (at your option) any later version.
//  
//  SmartSlog Library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SmartSlog Library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor,
//  Boston, MA  02110-1301  USA
//  </copyright>
//  
//  <author>SmartSlog Team (Aleksandr A. Lomov)</author>
//  <email>mailto:lomov@cs.karelia.ru</email>
//  <author>Andrey S. Vdovenko</author>
//  <email>mailto:vdovenko@cs.karelia.ru</email>
//  <created>22.06.2016 10:36</created>
//  <lastedit>05.07.2016 14:38</lastedit>
//  ------------------------------------------------------------------------
#define INCLUDE_PROPERTY_ISA
#define INCLUDE_PROPERTY_HAS
#define INCLUDE_CLASS_UNIVERSUM
#define INCLUDE_CLASS_WORLD
#define INCLUDE_CLASS_NOTHING
#define INCLUDE_CLASS_THING

using System.Collections.Generic;

namespace PetrSU.SmartSlog.Demo.HelloWorldSubscribe
{
    // Add a reference
    
    public static class OntologyStructure
    {
        static OntologyStructure()
        {

            List<Property> properties = new List<Property>();
            List<OntologyClass> superclasses = new List<OntologyClass>();

#if INCLUDE_PROPERTY_ISA
            IsA = new Property("IsA",
                maxCardinality: -1, minCardinality: -1,
                isObject: true);
#endif
#if INCLUDE_PROPERTY_HAS
            Has = new Property("Has",
                maxCardinality: -1, minCardinality: -1,
                isObject: false);
#endif




#if INCLUDE_CLASS_UNIVERSUM
#if INCLUDE_PROPERTY_HAS
            properties.Add(Has);
#endif
#if INCLUDE_PROPERTY_ISA
            properties.Add(IsA);
#endif

#if INCLUDE_CLASS_UNIVERSUM
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

            Universum = new OntologyClass("http://X#Universum", properties, superclasses);
            properties = new List<Property>();
            superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_WORLD

#if INCLUDE_CLASS_WORLD
#if INCLUDE_CLASS_THING
            superclasses.Add(Thing);
#endif
#endif

            World = new OntologyClass("http://X#World", properties, superclasses);
            properties = new List<Property>();
            superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_PROPERTY_HAS
            properties.Add(Has);
#endif
#if INCLUDE_PROPERTY_ISA
            properties.Add(IsA);
#endif

#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_UNIVERSUM
            superclasses.Add(Universum);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_WORLD
            superclasses.Add(World);
#endif
#endif

            Nothing = new OntologyClass("http://www.w3.org/2002/07/owl#Nothing", properties, superclasses);
            properties = new List<Property>();
            superclasses = new List<OntologyClass>();
#endif
#if INCLUDE_CLASS_THING


            Thing = new OntologyClass("http://www.w3.org/2002/07/owl#Thing", properties, superclasses);
            properties = new List<Property>();
            superclasses = new List<OntologyClass>();
#endif



        }

#if INCLUDE_CLASS_UNIVERSUM
        public static OntologyClass Universum { get; private set; }
#endif
#if INCLUDE_CLASS_WORLD
        public static OntologyClass World { get; private set; }
#endif
#if INCLUDE_CLASS_NOTHING
        public static OntologyClass Nothing { get; private set; }
#endif
#if INCLUDE_CLASS_THING
        public static OntologyClass Thing { get; private set; }
#endif


#if INCLUDE_PROPERTY_ISA
        public static Property IsA { get; private set; }
#endif
#if INCLUDE_PROPERTY_HAS
        public static Property Has { get; private set; }
#endif


        public static void RegisterOntology(ISession registrator)
        {
            if (registrator == null)
            {
                throw new System.ArgumentNullException("node");
            }

#if INCLUDE_PROPERTY_ISA
            registrator.RegisterEntity(IsA);
#endif
#if INCLUDE_PROPERTY_HAS
            registrator.RegisterEntity(Has);
#endif




#if INCLUDE_CLASS_UNIVERSUM
            registrator.RegisterEntity(Universum);
#endif
#if INCLUDE_CLASS_WORLD
            registrator.RegisterEntity(World);
#endif
#if INCLUDE_CLASS_NOTHING
            registrator.RegisterEntity(Nothing);
#endif
#if INCLUDE_CLASS_THING
            registrator.RegisterEntity(Thing);
#endif



        }
    }
}

